/*
 * Copyright (c) 2015 Samsung Electronics Co., Ltd. All rights reserved.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

function keyEventCB(event) {
    if (event.keyName === "back") {
        try {
            tizen.application.getCurrentApplication().exit();
        } catch (ignore) {

        }
    }
}

function streamCb(stream) {
    var URL = window.URL || window.webkitURL,
        objVideo = document.querySelector("#videoMirror");

    objVideo.src = URL.createObjectURL(stream);
    objVideo.play();
}

function setDefaultViews() {
    var defaultErrorMessage = document.querySelector("#errorMessage");

    defaultErrorMessage.style.display = "none";
}

function setDefaultVariables() {
    navigator.getUserMedia = navigator.getUserMedia || navigator.webkitGetUserMedia;
    if (!navigator.getUserMedia) {
        return false;
    }

    return true;
}

function setDefaultEvents() {
    document.addEventListener("tizenhwkey", keyEventCB);
    if (navigator.getUserMedia) {
        navigator.getUserMedia({
                video: true
            },
            streamCb,
            function(err) {
                console.log(err);
            });

    } else {
        return false;
    }

    return true;
}

function init() {
    if (setDefaultVariables() && setDefaultEvents()) {
        setDefaultViews();
        console.log("App: init");
    } else {
        console.error("App: init: Error");
        alert("Some error occured during start the app.");
        try {
            tizen.application.getCurrentApplication().exit();
        } catch (ignore) {

        }
    }
}

window.onload = init;